"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import typing

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class MlkemTest(google.protobuf.message.Message):
    """A single ML-KEM test vector. Can be used for testing encapsulation (uses pk, sk, ct,
    and ss) or decapsulation (uses sk, ct, and ss).
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ID_FIELD_NUMBER: builtins.int
    TYPE_FIELD_NUMBER: builtins.int
    COMMENT_FIELD_NUMBER: builtins.int
    FLAGS_FIELD_NUMBER: builtins.int
    PK_FIELD_NUMBER: builtins.int
    SK_FIELD_NUMBER: builtins.int
    CT_FIELD_NUMBER: builtins.int
    SS_FIELD_NUMBER: builtins.int
    id: builtins.int
    """The test ID, unique in its set of vectors."""
    type: builtins.str
    """The type of test. One of: valid, invalid, acceptable."""
    comment: builtins.str
    """A comment on the test."""
    pk: builtins.bytes
    """The public (encapsulation) key."""
    sk: builtins.bytes
    """The secret (decapsulation) key."""
    ct: builtins.bytes
    """The ciphertext resulting from ML-KEM.Encaps()."""
    ss: builtins.bytes
    """The shared secret resulting from ML-KEM.Encaps()."""
    @property
    def flags(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """Flags that categorize this test."""

    def __init__(
        self,
        *,
        id: builtins.int = ...,
        type: builtins.str = ...,
        comment: builtins.str = ...,
        flags: collections.abc.Iterable[builtins.str] | None = ...,
        pk: builtins.bytes = ...,
        sk: builtins.bytes = ...,
        ct: builtins.bytes = ...,
        ss: builtins.bytes = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["comment", b"comment", "ct", b"ct", "flags", b"flags", "id", b"id", "pk", b"pk", "sk", b"sk", "ss", b"ss", "type", b"type"]) -> None: ...

global___MlkemTest = MlkemTest

@typing.final
class MlkemVectors(google.protobuf.message.Message):
    """A set of ML-KEM test vectors."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class NotesEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        value: builtins.str
        def __init__(
            self,
            *,
            key: builtins.str = ...,
            value: builtins.str = ...,
        ) -> None: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    SOURCE_FIELD_NUMBER: builtins.int
    SOURCE_DESC_FIELD_NUMBER: builtins.int
    SOURCE_URL_FIELD_NUMBER: builtins.int
    COMPLIANCE_FIELD_NUMBER: builtins.int
    NOTES_FIELD_NUMBER: builtins.int
    PARAMSET_FIELD_NUMBER: builtins.int
    TESTS_FIELD_NUMBER: builtins.int
    source: builtins.str
    """The source of the test vectors."""
    source_desc: builtins.str
    """Description of the source."""
    source_url: builtins.str
    """The URL of the source."""
    compliance: builtins.bool
    """Whether these are compliance test vectors or not."""
    paramset: builtins.str
    """The ML-KEM parameter set."""
    @property
    def notes(self) -> google.protobuf.internal.containers.ScalarMap[builtins.str, builtins.str]:
        """A dictionary of test flags and their description."""

    @property
    def tests(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___MlkemTest]:
        """The test vectors."""

    def __init__(
        self,
        *,
        source: builtins.str = ...,
        source_desc: builtins.str = ...,
        source_url: builtins.str = ...,
        compliance: builtins.bool = ...,
        notes: collections.abc.Mapping[builtins.str, builtins.str] | None = ...,
        paramset: builtins.str = ...,
        tests: collections.abc.Iterable[global___MlkemTest] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["compliance", b"compliance", "notes", b"notes", "paramset", b"paramset", "source", b"source", "source_desc", b"source_desc", "source_url", b"source_url", "tests", b"tests"]) -> None: ...

global___MlkemVectors = MlkemVectors
